<template>
  <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]" horizontal>
    <template v-slot:before>
      <div class="q-pa-lg bg-grey-1 max_width" role="region" aria-label="details Label">
        <div v-if="label_id">

          <q-card class="q-pb-lg shadow-1" flat bordered>
            <q-card-section class="text-primary text-weight-bold label__heading" role="heading">
              <div><span>{{ label_id }}</span></div>
            </q-card-section>
            <div class="row" role="row">
              <div class="col-2 label" role="rowheader">ID</div>
              <div class="col-8 value detail_bg" role="cell">{{ label_id }}</div>
            </div>
            <div class="row" role="row" v-if="label_lang">
              <div class="col-2 label" role="rowheader">Taal</div>
              <div class="col-2 value detail_bg" role=cell>{{ label_lang }}</div>
            </div>
            <div class="row" role="row" v-if="link_role">
              <div class="col-2 label" role="rowheader">Rol</div>
              <div class="col-8 value detail_bg" role="cell">{{ link_role }}</div>
            </div>
            <div class="row" role="row" v-if="label_text">
              <div class="col-2 label" role="rowheader">Label</div>
              <div class="col-8 value detail_bg" role="cell">{{ label_text }}</div>
            </div>
          </q-card>

          <q-card v-if="backrefs" class="q-mt-lg" flat bordered role="region" aria-label="Gebruikt door">
            <table>
              <tr>
                <th>Bron</th>
                <th>locatie</th>
              </tr>

              <tr v-for="(backref, index) in backrefs" :key="index"
                  :class="{active: current===backref.concept_id}"
                  v-on:click="concept_clicked(backref.concept)"
                  class="pointer">
                <td class="detail_bg">
                  <span style="white-space: nowrap;">
                    <q-icon v-if="current===backref.concept_id" name="arrow_right" size="30"></q-icon>
                    {{ backref.type }}
                  </span>
                </td>
                <td class="detail_bg">{{ backref.concept_name }}</td>
              </tr>
            </table>
          </q-card>

        </div>
      </div>
    </template>

    <template v-slot:separator>
    </template>

    <template v-slot:after>
      <div v-if="node">
        <CellValue :node="node" v-on:close_detail="close_detail"></CellValue>
      </div>
    </template>

  </q-splitter>
</template>

<script>
import {api} from 'boot/axios'
import CellValue from "components/CellValue";


export default {
  name: "LabelDetail",
  components: {CellValue},
  mounted() {
    this.label_lang = this.$route.params["label_lang"]
    this.label_text = this.$route.params["label_text"]
    this.link_role = this.$route.params["link_role"]
    this.label_lang = this.$route.params["label_lang"]
    this.fetchData()
  },
  data() {
    return {
      label_lang: undefined,
      link_role: undefined,
      label_text: undefined,
      backrefs: undefined,
      node: undefined,
      current: undefined,
      panelWidth: 50
    }
  },
  watch: {
    label_id: function () {
      this.label_lang = this.$route.params["label_lang"]
      this.label_text = this.$route.params["label_text"]
      this.link_role = this.$route.params["link_role"]
      this.label_lang = this.$route.params["label_lang"]
      this.fetchData()
    }
  },
  props: {
    label_id: String,
    dts_name: String,
    nt_version: String,
  },
  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/labels/backref/" + this.label_id,
          {params: {nt_version: this.nt_version, role: this.link_role, lang: this.label_lang}})
        .then(
          result => {
            this.backrefs = result.data
            if (this.backrefs && this.backrefs[0] && this.backrefs[0].concept) {
              this.concept_clicked(this.backrefs[0].concept)
            }
          }
        )
    },
    concept_clicked: function (concept) {
      if (concept) {
        this.node = {concept: concept}
        this.current = concept.id
        if (this.panelWidth === 100) {
          this.panelWidth = 50
        }
      }
    },
    close_detail: function () {
      this.panelWidth = 100
    }
  }
}
</script>

<style scoped lang="scss">
.label__heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
  margin-bottom: 10px;
}

.value {
  border-radius: 5px;
  padding: 5px 0 5px 10px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

.max_width {
  width: 100%;
}

table {
  border-spacing: 5px;
  width: 100%;
}

th {
  text-align: left;
}

td.tiny {
  width: 10%;
}

.pointer {
  cursor: pointer;
}

th {
  text-align: left;
}

table {
  border-collapse: collapse;
}

td, th {
  border: 1px solid $blue-grey;
  padding: 2px 5px;
}

tr.pointer:hover {
  background-color: $list_selected_bg;
  opacity: 0.8;
  color: white;
}

tr.pointer:hover td {
  background: transparent;
}

tr.pointer .active,
.active > .detail_bg {
  background-color: transparent;
}


</style>
